Loading...
Searching...
No Matches
juce::FontOptions Class Referencefinal

## Detailed Description

Options that describe a particular font.

Used to construct Font instances in a fluent style.

See also
  Typeface, Font

The documentation for this class was generated from the following file:

- juce_graphics/fonts/juce_FontOptions.h

## Public Member Functions

| FontOptions ()
| Constructs the default set of options.
| FontOptions (float fontHeight)
| Constructs the default set of options with a custom height.
| FontOptions (float fontHeight, int styleFlags)
| Constructs the default set of options with a custom height and style.
| FontOptions (const String &typefaceName, float fontHeight, int styleFlags)
| Constructs the default set of options with a given typeface and parameters.
| FontOptions (const String &typefaceName, const String &typefaceStyle, float fontHeight)
| Constructs the default set of options with a given typeface and parameters.
| FontOptions (const Typeface::Ptr &typeface)
| Constructs the default set of options with a given typeface.
FontOptions | withName (String x) const
| Returns a copy of these options with a new typeface name.
FontOptions | withStyle (String x) const
| Returns a copy of these options with a new typeface style.
FontOptions | withTypeface (Typeface::Ptr x) const
| Returns a copy of these options with a new typeface.
FontOptions | withFallbacks (std::vector< String > x) const
| Returns a copy of these options with a new set of preferred fallback family names.
FontOptions | withFallbackEnabled (bool x=true) const
| Returns a copy of these options with font fallback enabled or disabled.
FontOptions | withHeight (float x) const
| Returns a copy of these options with the specified height in JUCE units (can be fractional).
FontOptions | withPointHeight (float x) const
| Returns a copy of these options with the specified height in points (can be fractional).
FontOptions | withKerningFactor (float x) const
| Returns a copy of these options with the specified extra kerning factor (also called "tracking").
FontOptions | withHorizontalScale (float x) const
| Returns a copy of these options with the specified horizontal scale factor, defaults to 1.0.
FontOptions | withUnderline (bool x=true) const
| Returns a copy of these options with underline enabled or disabled, defaults to disabled.
FontOptions | withMetricsKind (TypefaceMetricsKind x) const
| Returns a copy of these options with the specified metrics kind.
FontOptions | withAscentOverride (std::optional< float > x) const
| Returns a copy of these options with the specified font metrics value override.
FontOptions | withDescentOverride (std::optional< float > x) const
| Returns a copy of these options with the specified font metrics value override.
FontOptions | withFeatureSetting (FontFeatureSetting featureSetting) const
| Returns a copy of these options with the specified font feature setting added or updated.
FontOptions | withFeatureRemoved (FontFeatureTag featureTag) const
| Returns a copy of these options with the specified feature removed.
FontOptions | withFeatureEnabled (FontFeatureTag tag) const
| Returns a copy of these options with the specified feature enabled.
FontOptions | withFeatureDisabled (FontFeatureTag tag) const
| Returns a copy of these options with the specified feature disabled.
auto | getName () const
auto | getStyle () const
auto | getTypeface () const
auto | getFallbacks () const
auto | getHeight () const
auto | getPointHeight () const
auto | getKerningFactor () const
auto | getHorizontalScale () const
auto | getFallbackEnabled () const
auto | getUnderline () const
auto | getMetricsKind () const
auto | getAscentOverride () const
auto | getDescentOverride () const
Span< const FontFeatureSetting > | getFeatureSettings () const &
Span< const FontFeatureSetting > | getFeatureSettings () const &&=delete
bool | operator== (const FontOptions &other) const
| Equality operator.
bool | operator!= (const FontOptions &other) const
| Inequality operator.
bool | operator< (const FontOptions &other) const
| Less-than operator.
bool | operator<= (const FontOptions &other) const
| Less-than-or-equal operator.
bool | operator> (const FontOptions &other) const
| Greater-than operator.
bool | operator>= (const FontOptions &other) const
| Greater-than-or-equal operator.

## Constructors and Destructors

## FontOptions() [1/6]

juce::FontOptions::FontOptions | ( |  | ) |

Constructs the default set of options.

Referenced by operator!=(), operator<(), operator<=(), operator==(), operator>(), operator>=(), withAscentOverride(), withDescentOverride(), withFallbackEnabled(), withFallbacks(), withFeatureDisabled(), withFeatureEnabled(), withFeatureRemoved(), withFeatureSetting(), withHeight(), withHorizontalScale(), withKerningFactor(), withMetricsKind(), withName(), withPointHeight(), withStyle(), withTypeface(), and withUnderline().

## FontOptions() [2/6]

juce::FontOptions::FontOptions | ( | float | fontHeight | ) |

explicit

Constructs the default set of options with a custom height.

## FontOptions() [3/6]

juce::FontOptions::FontOptions | ( | float | fontHeight,
|  | int | styleFlags )

Constructs the default set of options with a custom height and style.

Parameters

  fontHeight | the height in pixels (can be fractional)
  styleFlags | the style to use - this can be a combination of the Font::bold, Font::italic and Font::underlined, or just Font::plain for the normal style.

See also
  Font::FontStyleFlags, Font::getDefaultSansSerifFontName

## FontOptions() [4/6]

juce::FontOptions::FontOptions | ( | const String & | typefaceName,
|  | float | fontHeight,
|  | int | styleFlags )

Constructs the default set of options with a given typeface and parameters.

Parameters

  typefaceName | the font family of the typeface to use
  fontHeight | the height in pixels (can be fractional)
  styleFlags | the style to use - this can be a combination of the Font::bold, Font::italic and Font::underlined, or just Font::plain for the normal style.

See also
  Font::FontStyleFlags, Font::getDefaultSansSerifFontName

## FontOptions() [5/6]

juce::FontOptions::FontOptions | ( | const String & | typefaceName,
|  | const String & | typefaceStyle,
|  | float | fontHeight )

Constructs the default set of options with a given typeface and parameters.

Parameters

  typefaceName | the font family of the typeface to use
  typefaceStyle | the font style of the typeface to use
  fontHeight | the height in pixels (can be fractional)

## FontOptions() [6/6]

juce::FontOptions::FontOptions | ( | const Typeface::Ptr & | typeface | ) |

Constructs the default set of options with a given typeface.

## Member Functions

## withName()

FontOptions juce::FontOptions::withName | ( | String | x | ) | const

inline nodiscard

Returns a copy of these options with a new typeface name.

If the options include a non-null Typeface::Ptr, this will be ignored. Otherwise, a suitable typeface will be located based on the typeface name and style strings.

References FontOptions(), jassertfalse, juce::withMember(), and x.

Referenced by withTypeface().

## withStyle()

FontOptions juce::FontOptions::withStyle | ( | String | x | ) | const

inline nodiscard

Returns a copy of these options with a new typeface style.

If the options include a non-null Typeface::Ptr, this will be ignored. Otherwise, a suitable typeface will be located based on the typeface name and style strings.

References FontOptions(), jassertfalse, juce::withMember(), and x.

## withTypeface()

FontOptions juce::FontOptions::withTypeface | ( | Typeface::Ptr | x | ) | const

inline nodiscard

Returns a copy of these options with a new typeface.

If the typeface is non-null, it takes precedence over the name and style strings.

References FontOptions(), jassert, juce::withMember(), withName(), and x.

## withFallbacks()

FontOptions juce::FontOptions::withFallbacks | ( | std::vector< String > | x | ) | const

inline nodiscard

Returns a copy of these options with a new set of preferred fallback family names.

References FontOptions(), juce::withMember(), and x.

## withFallbackEnabled()

FontOptions juce::FontOptions::withFallbackEnabled | ( | bool | x = true | ) | const

inline nodiscard

Returns a copy of these options with font fallback enabled or disabled.

References FontOptions(), juce::withMember(), and x.

## withHeight()

FontOptions juce::FontOptions::withHeight | ( | float | x | ) | const

inline nodiscard

Returns a copy of these options with the specified height in JUCE units (can be fractional).

FontOptions can hold either a JUCE height, set via withHeight(), or a point height, set via withPointHeight(). After calling withHeight(), the result of getPointHeight() will be -1.0f to indicate that the point height is unset.

For more information about how JUCE font heights work, see Font::setHeight().

References FontOptions(), jassert, and x.

## withPointHeight()

FontOptions juce::FontOptions::withPointHeight | ( | float | x | ) | const

inline nodiscard

Returns a copy of these options with the specified height in points (can be fractional).

After calling withPointHeight(), the result of getHeight() will be -1.0f to indicate that the JUCE height is unset.

For more information about how point heights work, see Font::setPointHeight().

References FontOptions(), jassert, and x.

## withKerningFactor()

FontOptions juce::FontOptions::withKerningFactor | ( | float | x | ) | const

inline nodiscard

Returns a copy of these options with the specified extra kerning factor (also called "tracking").

References FontOptions(), juce::withMember(), and x.

## withHorizontalScale()

FontOptions juce::FontOptions::withHorizontalScale | ( | float | x | ) | const

inline nodiscard

Returns a copy of these options with the specified horizontal scale factor, defaults to 1.0.

References FontOptions(), juce::withMember(), and x.

## withUnderline()

FontOptions juce::FontOptions::withUnderline | ( | bool | x = true | ) | const

inline nodiscard

Returns a copy of these options with underline enabled or disabled, defaults to disabled.

References FontOptions(), juce::withMember(), and x.

## withMetricsKind()

FontOptions juce::FontOptions::withMetricsKind | ( | TypefaceMetricsKind | x | ) | const

inline nodiscard

Returns a copy of these options with the specified metrics kind.

References FontOptions(), juce::withMember(), and x.

Referenced by juce::LookAndFeel::withDefaultMetrics().

## withAscentOverride()

FontOptions juce::FontOptions::withAscentOverride | ( | std::optional< float > | x | ) | const

inline nodiscard

Returns a copy of these options with the specified font metrics value override.

std::nullopt indicates that the font should use the built-in typeface metric; otherwise, the ascent value will be found by multiplying the provided value by the font size in points.

References FontOptions(), juce::withMember(), and x.

## withDescentOverride()

FontOptions juce::FontOptions::withDescentOverride | ( | std::optional< float > | x | ) | const

inline nodiscard

Returns a copy of these options with the specified font metrics value override.

std::nullopt indicates that the font should use the built-in typeface metric; otherwise, the descent value will be found by multiplying the provided value by the font size in points.

References FontOptions(), juce::withMember(), and x.

## withFeatureSetting()

FontOptions juce::FontOptions::withFeatureSetting | ( | FontFeatureSetting | featureSetting | ) | const

nodiscard

Returns a copy of these options with the specified font feature setting added or updated.

References FontOptions().

Referenced by withFeatureDisabled(), and withFeatureEnabled().

## withFeatureRemoved()

FontOptions juce::FontOptions::withFeatureRemoved | ( | FontFeatureTag | featureTag | ) | const

nodiscard

Returns a copy of these options with the specified feature removed.

If the featureTag corresponds to a recognised default-enabled font feature (e.g., "calt", "ccmp", "liga", "locl", "mark", "mkmk", "rlig"), it's setting will be reset to its default state.

References FontOptions().

## withFeatureEnabled()

FontOptions juce::FontOptions::withFeatureEnabled | ( | FontFeatureTag | tag | ) | const

inline nodiscard

Returns a copy of these options with the specified feature enabled.

References juce::FontFeatureSetting::featureEnabled, FontOptions(), and withFeatureSetting().

## withFeatureDisabled()

FontOptions juce::FontOptions::withFeatureDisabled | ( | FontFeatureTag | tag | ) | const

inline nodiscard

Returns a copy of these options with the specified feature disabled.

References juce::FontFeatureSetting::featureDisabled, FontOptions(), and withFeatureSetting().

## getName()

auto juce::FontOptions::getName | ( |  | ) | const

inline nodiscard

See also
  withName()

## getStyle()

auto juce::FontOptions::getStyle | ( |  | ) | const

inline nodiscard

See also
  withStyle()

## getTypeface()

auto juce::FontOptions::getTypeface | ( |  | ) | const

inline nodiscard

See also
  withTypeface()

## getFallbacks()

auto juce::FontOptions::getFallbacks | ( |  | ) | const

inline nodiscard

See also
  withFallbacks()

## getHeight()

auto juce::FontOptions::getHeight | ( |  | ) | const

inline nodiscard

See also
  withHeight()

## getPointHeight()

auto juce::FontOptions::getPointHeight | ( |  | ) | const

inline nodiscard

See also
  withPointHeight()

## getKerningFactor()

auto juce::FontOptions::getKerningFactor | ( |  | ) | const

inline nodiscard

See also
  withKerningFactor()

## getHorizontalScale()

auto juce::FontOptions::getHorizontalScale | ( |  | ) | const

inline nodiscard

See also
  withHorizontalScale()

## getFallbackEnabled()

auto juce::FontOptions::getFallbackEnabled | ( |  | ) | const

inline nodiscard

See also
  withFallbackEnabled()

## getUnderline()

auto juce::FontOptions::getUnderline | ( |  | ) | const

inline nodiscard

See also
  withUnderline()

## getMetricsKind()

auto juce::FontOptions::getMetricsKind | ( |  | ) | const

inline nodiscard

See also
  withMetricsKind()

## getAscentOverride()

auto juce::FontOptions::getAscentOverride | ( |  | ) | const

inline nodiscard

See also
  withAscentOverride()

## getDescentOverride()

auto juce::FontOptions::getDescentOverride | ( |  | ) | const

inline nodiscard

See also
  withDescentOverride()

## getFeatureSettings() [1/2]

Span< const FontFeatureSetting > juce::FontOptions::getFeatureSettings | ( |  | ) | const &

inline nodiscard

See also
  withFeatureSetting()

## getFeatureSettings() [2/2]

Span< const FontFeatureSetting > juce::FontOptions::getFeatureSettings | ( |  | ) | const &&

nodiscard delete

## operator==()

bool juce::FontOptions::operator== | ( | const FontOptions & | other | ) | const

nodiscard

Equality operator.

References FontOptions().

## operator!=()

bool juce::FontOptions::operator!= | ( | const FontOptions & | other | ) | const

nodiscard

Inequality operator.

References FontOptions().

## operator<()

bool juce::FontOptions::operator< | ( | const FontOptions & | other | ) | const

nodiscard

Less-than operator.

Allows FontOptions to be used as keys in a map.

References FontOptions().

## operator<=()

bool juce::FontOptions::operator<= | ( | const FontOptions & | other | ) | const

nodiscard

Less-than-or-equal operator.

References FontOptions().

## operator>()

bool juce::FontOptions::operator> | ( | const FontOptions & | other | ) | const

nodiscard

Greater-than operator.

References FontOptions().

## operator>=()

bool juce::FontOptions::operator>= | ( | const FontOptions & | other | ) | const

nodiscard

Greater-than-or-equal operator.

References FontOptions(), and juce::portable.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited